package com.cf.imes.module.system.service.datasource;

import java.util.*;
import com.cf.imes.module.system.controller.admin.datasource.vo.*;
import com.cf.imes.module.system.dal.dataobject.datasource.DataSourceDO;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.common.pojo.PageParam;

import javax.validation.Valid;

/**
 * 系统数据源 Service 接口
 *
 * @author 晨丰科技
 */
public interface DataSourceService {

    /**
     * 创建系统数据源
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createDataSource(@Valid DataSourceSaveReqVO createReqVO);

    /**
     * 更新系统数据源
     *
     * @param updateReqVO 更新信息
     */
    void updateDataSource(@Valid DataSourceSaveReqVO updateReqVO);

    /**
     * 删除系统数据源
     *
     * @param id 编号
     */
    void deleteDataSource(Long id);

    /**
     * 获得系统数据源
     *
     * @param id 编号
     * @return 系统数据源
     */
    DataSourceDO getDataSource(Long id);

    /**
     * 获得系统数据源分页
     *
     * @param pageReqVO 分页查询
     * @return 系统数据源分页
     */
    PageResult<DataSourceDO> getDataSourcePage(DataSourcePageReqVO pageReqVO);

    List<DataSourceDO> list(Integer type);

    List<DataSourceRespVO> list();
}